import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;

import se.rupy.http.Event;
import se.rupy.http.Session;

public class Channel extends LinkedList {
	private Map push;
	private String name;
	private String host;
	private int length;
	private boolean persistent;
	
	public Channel(String name, String host, boolean persistent) {
		this.name = name;
		this.persistent = persistent;
		
		push = new HashMap();
	}
	
    public boolean add(Object message) {
    	if(message == null) {
    		// Daemon listener swallowed message?
    		return false;
    	}
    	
    	length++;
    	
		if(size() == Poll.CHANNEL_CACHE) {
			remove(0);
		}
    	
    	return super.add(message);
    }
	
	protected Event add(Event event) {
		//Broadcast.log.message("" + push.containsValue(event));
		if(!push.containsValue(event)) {
			//Broadcast.log.message(push);
			return (Event) push.put(event.session().key(), event);
		}
		else {
			return event;
		}
		
		//return null;
	}
	
	protected Event remove(Event event) {
		return (Event) push.remove(event.session().key());
	}
	
	protected Map push() {
		return push;
	}
	
	protected String name() {
		return name;
	}
	
	protected String host() {
		return host;
	}
	
	protected int length() {
		return length;
	}
	
	protected boolean persistent() {
		return persistent;
	}
	
	protected Event push(Session session) {
		return (Event) push.get(session.key());
	}
	
	protected String list() {
		StringBuilder list = new StringBuilder();
		Iterator it = push.values().iterator();
		boolean first = true;
		
		//System.out.println(push); // TODO: Remove.
		
		while(it.hasNext()) {
			Event event = (Event) it.next();
			Session session = event.session();
			
			if(!first) {
				list.append(", ");
			}
			
			list.append(event.remote());
			first = false;
		}

		return list.toString();
	}
	
	//public String toString() {
	//	return "channel " + name + " [" + host + "]" + (persistent ? " persistent " : " ") + push;
	//}
}
