import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.zip.GZIPOutputStream;

import se.rupy.http.Deploy;
import se.rupy.http.Event;
import se.rupy.http.Service;

public class Talk extends Service {
	public String path() { return "/res/talk.js"; }
	public void filter(Event event) throws Event, Exception {
		event.reply().header("P3P", "CP=\"NOI DSP COR NID ADM DEV PSA OUR IND UNI PUR COM NAV INT STA\"");
		event.reply().header("Content-Encoding", "gzip");

		File from = new File("app/" + Broadcast.log.host + "/res/talk.js");
		File to = new File("app/" + Broadcast.log.host + "/res/talk.js.gzip");
		
		boolean zip = false;
		
		if(to.exists()) {
			if(from.lastModified() > to.lastModified()) {
				zip = true;
			}
		}
		else {
			to.createNewFile();
			zip = true;
		}
		
		if(zip) {
			FileInputStream in = new FileInputStream(from);
			GZIPOutputStream out = new GZIPOutputStream(new FileOutputStream(to));

			Deploy.pipe(in, out);

			in.close();

			out.finish();
			out.close();
		}

		FileInputStream in = new FileInputStream(to);
		Deploy.pipe(in, event.reply().output(to.length()));
		in.close();
	}
}